/*
 *		This Code Was Created By Jeff Molofee and GB Schmick 2000
 *		A HUGE Thanks To Fredric Echols For Cleaning Up
 *		And Optimizing The Base Code, Making It More Flexible!
 *		If You've Found This Code Useful, Please Let Me Know.
 *		Visit Our Sites At www.tiptup.com and nehe.gamedev.net
 */


#include <math.h>		// Header File For Windows
#include <windows.h>		// Header File For Windows
#include <stdio.h>			// Header File For Standard Input/Output
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library

HDC		hDC=NULL;			// Private GDI Device Context
HGLRC	hRC=NULL;			// Permanent Rendering Context
HWND	hWnd=NULL;			// Holds Our Window Handle

/*
//SCREEN SAVER 
  #define WIN32_LEAN_AND_MEAN
  #define STRICT
  //#include 
  #include "scrplus.h"

  LRESULT CALLBACK MySaverProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
  {  
            
    return DefScreenSaverProc(hwnd,msg,wParam,lParam);       
    
  }
*/


bool	keys[256];			// Array Used For The Keyboard Routine
bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;	// Fullscreen Flag Set To Fullscreen Mode By Default
bool	light;				// Lighting ON/OFF
bool    wireframe = FALSE;  // Wireframe ON/OFF
bool	lp;					// L Pressed? 
bool	fp;					// F Pressed? 
bool    sp;                 // Spacebar Pressed? ( NEW )
bool    wp;                 // W pressed?

bool    aq;
bool    sq;

int		part1;				// Start Of Disc ( NEW )
int		part2;				// End Of Disc ( NEW )
int		p1=0;				// Increase 1 ( NEW )
int		p2=1;				// Increase 2 ( NEW )

float	slowdown=.50f;				// Slow Down Particles
int loop;

float V;
float Angle;
float AngleZ;


GLUquadricObj *quadratic;	// Storage For Our Quadratic Objects ( NEW )
GLuint	texture[3];

GLfloat ABS(GLfloat A)
{
  if (A < 0)
  A = -A; 
  return A;
}

//#define	MAX_PARTICLES	5000

GLuint	col;						// Current Color Selection



//GLfloat LightAmbient[]=		{ 0.7f, 0.7f, 0.7f, 1.0f };
//GLfloat LightDiffuse[]=		{ 1.0f, 1.0f, 1.0f, 1.0f };
//GLfloat LightPosition[]=	{ 0.0f, 0.0f, -11.0f, 1.0f };

GLuint	fogMode[]= { GL_EXP, GL_EXP2, GL_LINEAR };	// Storage For Three Types Of Fog
GLuint	fogfilter = 0;								// Which Fog Mode To Use 
GLfloat	fogColor[4] = {.25, .25, .25, 1};		// Fog Color


GLuint	filter;				// Which Filter To Use
GLuint  object=0;			// Which Object To Draw (NEW)

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc

AUX_RGBImageRec *LoadBMP(char *Filename)				// Loads A Bitmap Image
{
	FILE *File=NULL;									// File Handle

	if (!Filename)										// Make Sure A Filename Was Given
	{
		return NULL;									// If Not Return NULL
	}

	File=fopen(Filename,"r");							// Check To See If The File Exists

	if (File)											// Does The File Exist?
	{
		fclose(File);									// Close The Handle
		return auxDIBImageLoad(Filename);				// Load The Bitmap And Return A Pointer
	}

	return NULL;										// If Load Failed Return NULL
}


int LoadGLTextures()									// Load Bitmap And Convert To A Texture
{
        int Status=FALSE;								// Status Indicator
        AUX_RGBImageRec *TextureImage[1];				// Create Storage Space For The Textures
        memset(TextureImage,0,sizeof(void *)*1);		// Set The Pointer To NULL

        if (TextureImage[0]=LoadBMP("texture/clouds.bmp"))	// Load Particle Texture
        {
			Status=TRUE;								// Set The Status To TRUE
			glGenTextures(1, &texture[0]);				// Create One Texture

					// Create MipMapped Texture
    		glBindTexture(GL_TEXTURE_2D, texture[0]);
	    	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	    	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
	    	gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);           
        }

        if (TextureImage[0])							// If Texture Exists
		{
			if (TextureImage[0]->data)					// If Texture Image Exists
			{
				free(TextureImage[0]->data);			// Free The Texture Image Memory
			}
			free(TextureImage[0]);						// Free The Image Structure
		}

        if (TextureImage[0]=LoadBMP("texture/clouds.bmp"))	// Load Particle Texture
        {
			Status=TRUE;								// Set The Status To TRUE
			glGenTextures(1, &texture[1]);				// Create One Texture

					// Create MipMapped Texture
    		glBindTexture(GL_TEXTURE_2D, texture[1]);
	    	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	    	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
	    	gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);           
        }

        if (TextureImage[0])							// If Texture Exists
		{
			if (TextureImage[0]->data)					// If Texture Image Exists
			{
				free(TextureImage[0]->data);			// Free The Texture Image Memory
			}
			free(TextureImage[0]);						// Free The Image Structure
		}


        if (TextureImage[0]=LoadBMP("texture/asphalt.bmp"))	// Load Particle Texture
        {
			Status=TRUE;								// Set The Status To TRUE
			glGenTextures(1, &texture[1]);				// Create One Texture

					// Create MipMapped Texture
    		glBindTexture(GL_TEXTURE_2D, texture[2]);
	    	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	    	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
	    	gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);           
        }

        if (TextureImage[0])							// If Texture Exists
		{
			if (TextureImage[0]->data)					// If Texture Image Exists
			{
				free(TextureImage[0]->data);			// Free The Texture Image Memory
			}
			free(TextureImage[0]);						// Free The Image Structure
		}


        return Status;									// Return The Status
}


GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,500.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}


const int MAX2 = 500;
const int MAX = 15;

//GLfloat z[MAX][MAX];



GLfloat xtrans = MAX/2;
GLfloat xptrans = 0;
GLfloat ytrans = 0;
GLfloat yptrans = 0;
GLfloat ztrans = MAX/2;
GLfloat zptrans = 0;


float Progress = 0;

void DrawProgress()
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); 
  glLoadIdentity();
  glTranslatef(0,0,0);

  Progress += .2;
    
  
  glColor4f(1,1,1,1);
  glBegin(GL_QUADS);
    glVertex3f(-.8,-1.5,-5);
    glVertex3f(-.8,-1.7,-5);
    glVertex3f(Progress,-1.7,-5);
    glVertex3f(Progress,-1.5,-5);
  glEnd(); 
}


int InitGL(GLvoid)										// All Setup For OpenGL Goes Here
{
	if (!LoadGLTextures())								// Jump To Texture Loading Routine
	{
		return FALSE;									// If Texture Didn't Load Return FALSE
	}

	//glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping
	//glEnable(GL_LINE_SMOOTH);
//    glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
//	glShadeModel(GL_DITHER);							// Enable Smooth Shading

	glClearColor(0, 0, 0, 1.0f);				// Black Background
	glClearDepth(1);		
	//glClearDepth(-10.0f);		

    //glClearIndex(.1);
    							// Depth Buffer Setup
    
//	glEnable(GL_DEPTH_TEST);
	glEnable(GL_ALPHA_TEST);

//	glEnable(GL_LIGHTING);
 
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE);					// Type Of Blending To Perform

    //glEnable(GL_POINT_SMOOTH);
    //glEnable(GL_LINE_SMOOTH);
    //glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do

//    glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);	// Really Nice Perspective Calculations
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations
        
	//glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);		// Setup The Ambient Light
	//glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);		// Setup The Diffuse Light
	//glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);	// Position The Light
	//glEnable(GL_LIGHT1);								// Enable Light One


	glFogi(GL_FOG_MODE, fogMode[1]);			// Fog Mode
	glFogfv(GL_FOG_COLOR, fogColor);					// Set Fog Color
	glFogf(GL_FOG_DENSITY, .075);						// How Dense Will The Fog Be
	glHint(GL_FOG_HINT, GL_NICEST);					// Fog Hint Value
	glFogf(GL_FOG_START, 0.0f);							// Fog Start Depth
	glFogf(GL_FOG_END, 10.0f);							// Fog End Depth
	glEnable(GL_FOG);									// Enables GL_FOG


//	quadratic=gluNewQuadric();							// Create A Pointer To The Quadric Object (Return 0 If No Memory) (NEW)
//	gluQuadricNormals(quadratic, GLU_SMOOTH);			// Create Smooth Normals (NEW)
//	gluQuadricTexture(quadratic, GL_TRUE);				// Create Texture Coords (NEW)

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   
	return TRUE;										// Initialization Went OK
}


//GLfloat xp = 1;
//GLfloat yp = .9;
//GLfloat zp = 1.3;


GLfloat cx = -4;
GLfloat cy = -2;
GLfloat cz = -6;


GLfloat cxp = 0;
GLfloat cyp = 0;


//GLfloat r = 0;
//GLfloat g = 0;
//GLfloat b = 0;    

GLfloat	xrot=0;				// X Rotation
GLfloat	yrot=0;				// Y Rotation
GLfloat	zrot=0;				// Y Rotation
//GLfloat xspeed = 0;				// X Rotation Speed
//GLfloat yspeed = 0;				// Y Rotation Speed
//GLfloat zspeed = 0;				// Y Rotation Speed

//GLfloat RoomZrot = 0;

//GLfloat Dist;
//GLfloat cDist;
GLfloat Speed;

//xspeed = 0.5f;
//yspeed = 0.7f;
//int cntclr = 0;
//int max2 = 0;
GLfloat alpha=1;    
//long int COUNTER=0;


const float piover180 = 0.0174532925f;
GLfloat XPOS = -MAX/2;
GLfloat ZPOS = -MAX/2;
GLfloat XP=0;
GLfloat ZP=0;

GLfloat sceneroty;
GLfloat heading;
GLfloat walkbias = 0;
GLfloat walkbiasangle = 0;
GLfloat zprot;

GLfloat Z = 0;


GLfloat zz = 0;
GLfloat ZOOM = -5;

GLfloat ALPHAP = .01;
GLfloat ALPHA2 = 0;

GLfloat ALPHA = 1;

int DrawGLScene(GLvoid)									// Here's Where We Do All The Drawing
{

    glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);	// Clear The Screen And The Depth Buffer

    glEnable(GL_BLEND);


    //glBindTexture(GL_TEXTURE_2D,texture[0]);

  glDisable(GL_TEXTURE_2D);							// Enable Texture Mapping


  float size = 1+ALPHA2;
  float sqrsize = .1;
  float halfsqrsize = sqrsize/2;
  ALPHAP += -ALPHA2/150;
  ALPHA2 += ALPHAP;

  glLoadIdentity();   
  glTranslatef(0,0,ZOOM);
     

  glBegin(GL_TRIANGLE_STRIP);						// Build Quad From A TRIANGLE Strip

  for(GLfloat t = -size; t < size; t+=sqrsize)
  {
    for(GLfloat t2 = -size; t2 < size; t2+=sqrsize)
    {
      for(GLfloat t3 = -size; t3 < size; t3+=sqrsize)
      {

        ALPHA = 1-(hypot(hypot(t+halfsqrsize,t2+halfsqrsize),t3)/size);

        if (ALPHA > .005)
        {
        //glLoadIdentity();
        //glTranslatef(0,0,ZOOM);

        glColor4f(1,.5,.1,ALPHA/10);
        glVertex3f(t+halfsqrsize,t2+halfsqrsize,t3); // Top Right

        ALPHA = 1-(hypot(hypot(t-halfsqrsize,t2+halfsqrsize),t3)/size);
        glColor4f(1,.5,.1,ALPHA/10);    
        glVertex3f(t-halfsqrsize,t2+halfsqrsize,t3); // Top Left
        
        ALPHA = 1-(hypot(hypot(t+halfsqrsize,t2-halfsqrsize),t3)/size);
        glColor4f(1,.5,.1,ALPHA/10);    
        glVertex3f(t+halfsqrsize,t2-halfsqrsize,t3); // Bottom Right

        ALPHA = 1-(hypot(hypot(t-halfsqrsize,t2-halfsqrsize),t3)/size);
        glColor4f(1,.5,.1,ALPHA/10);
	    glVertex3f(t-halfsqrsize,t2-halfsqrsize,t3); // Bottom Left
	    }

//        glBegin(GL_TRIANGLE_STRIP);						// Build Quad From A TRIANGLE Strip
//        glTexCoord2f(1,0);  glVertex3f(t+0.1f,t2+0.1f,t3-.1); // Top Right
//	    glTexCoord2f(0,0);  glVertex3f(t-0.1f,t2+0.1f,t3-.1); // Top Left
//	    glTexCoord2f(1,1);  glVertex3f(t+0.1f,t2+0.1f,t3+.1); // Bottom Right
//	    glTexCoord2f(0,1);  glVertex3f(t-0.1f,t2+0.1f,t3+.1); // Bottom Left
//	    glEnd();										// Done Building TRIANGLE Strip

/*
        glBegin(GL_TRIANGLE_STRIP);						// Build Quad From A TRIANGLE Strip
        glTexCoord2f(1,0);  glVertex3f(t+0.1f,t2-0.1f,t3-.1); // Top Right
	    glTexCoord2f(0,0);  glVertex3f(t-0.1f,t2-0.1f,t3-.1); // Top Left
	    glTexCoord2f(1,1);  glVertex3f(t+0.1f,t2-0.1f,t3+.1); // Bottom Right
	    glTexCoord2f(0,1);  glVertex3f(t-0.1f,t2-0.1f,t3+.1); // Bottom Left
	    glEnd();										// Done Building TRIANGLE Strip
*/
//        glBegin(GL_TRIANGLE_STRIP);						// Build Quad From A TRIANGLE Strip
//        glTexCoord2f(1,0);  glVertex3f(t+0.1f,t2+0.1f,t3-.1); // Top Right
//	    glTexCoord2f(0,0);  glVertex3f(t+0.1f,t2-0.1f,t3-.1); // Top Left
//	    glTexCoord2f(1,1);  glVertex3f(t+0.1f,t2+0.1f,t3+.1); // Bottom Right
//	    glTexCoord2f(0,1);  glVertex3f(t+0.1f,t2-0.1f,t3+.1); // Bottom Left
//	    glEnd();										// Done Building TRIANGLE Strip
/*
        glBegin(GL_TRIANGLE_STRIP);						// Build Quad From A TRIANGLE Strip
        glTexCoord2f(1,0);  glVertex3f(t-0.1f,t2+0.1f,t3-.1); // Top Right
	    glTexCoord2f(0,0);  glVertex3f(t-0.1f,t2-0.1f,t3-.1); // Top Left
	    glTexCoord2f(1,1);  glVertex3f(t-0.1f,t2+0.1f,t3+.1); // Bottom Right
	    glTexCoord2f(0,1);  glVertex3f(t-0.1f,t2-0.1f,t3+.1); // Bottom Left
	    glEnd();										// Done Building TRIANGLE Strip
*/

      //glBegin(GL_TRIANGLE_STRIP);						// Build Quad From A Triangle Strip
      //glVertex3f(t+0.15f,Y+0.15f,Z-6); // Top Right
	  //glVertex3f(t-0.15f,Y+0.15f,Z-6); // Top Left
	  //glVertex3f(t+0.15f,Y-0.15f,Z-6); // Bottom Right
	  //glVertex3f(t-0.15f,Y-0.15f,Z-6); // Bottom Left
	  //glEnd();				
      }
    }						// Done Building Triangle Strip
  }
        glEnd();										// Done Building TRIANGLE Strip


   
    glLoadIdentity();  
    glTranslatef(0,0,ZOOM);

    xrot+=.7;
    yrot+=1;
    zrot+=.87;
    glRotatef(xrot, 1,0,0);
    glRotatef(yrot, 0,1,0);
    glRotatef(zrot, 0,0,1);
      
        
    //glDisable(GL_BLEND);
	glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping
    glBindTexture(GL_TEXTURE_2D,texture[2]);
 

    glColor4f(.5,.55,.6,1);
    glBegin(GL_TRIANGLE_STRIP);						// Build Quad From A TRIANGLE Strip
    glTexCoord2f(1,1);  glVertex3f(20,20,50); // Top Right
    glTexCoord2f(0,1);  glVertex3f(0 ,20,-5); // Top Left
    glTexCoord2f(1,0);  glVertex3f(20,-1,50); // Bottom Right
    glTexCoord2f(0,0);  glVertex3f(0 ,-1,-5); // Bottom Left
    glEnd();										// Done Building TRIANGLE Strip

    glColor4f(.6,.55,.5,1);
    glBegin(GL_TRIANGLE_STRIP);						// Build Quad From A TRIANGLE Strip
    glTexCoord2f(1,1);  glVertex3f(-20,20,50); // Top Right
    glTexCoord2f(0,1);  glVertex3f(0  ,20,-5); // Top Left
    glTexCoord2f(1,0);  glVertex3f(-20,-1,50); // Bottom Right
    glTexCoord2f(0,0);  glVertex3f(0  ,-1,-5); // Bottom Left
    glEnd();										// Done Building TRIANGLE Strip

    glColor4f(.4,.4,.4,1);
    glBegin(GL_TRIANGLE_STRIP);						// Build Quad From A TRIANGLE Strip
    glTexCoord2f(1,1);  glVertex3f(-20,-1,50); // Top Right
    glTexCoord2f(0,1);  glVertex3f(20 ,-1,50); // Top Left
    glTexCoord2f(1,0);  glVertex3f(0  ,-1,-5); // Bottom Right
    //glTexCoord2f(0,0);  glVertex3f(-20,-2,20); // Bottom Left
    glEnd();										// Done Building TRIANGLE Strip


  

   return TRUE;										// Keep Going

}

GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (fullscreen)										// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		ShowCursor(TRUE);								// Show Mouse Pointer
	}
}

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	HINSTANCE	hInstance;				// Holds The Instance Of The Application
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;	// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;						// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;	// Windows Style
	}

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,			// Extended Style For The Window
								"OpenGL",			// Class Name
								title,				// Window Title
								dwStyle,			// Window Style
								0, 0,				// Window Position
								width, height,		// Selected Width And Height
								NULL,				// No Parent Window
								NULL,				// No Menu
								hInstance,			// Instance
								NULL)))				// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	if (!InitGL())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	return TRUE;									// Success
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
{
	switch (uMsg)									// Check For Windows Messages
	{
		case WM_ACTIVATE:							// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					// Check Minimization State
			{
				active=TRUE;						// Program Is Active
			}
			else
			{
				active=FALSE;						// Program Is No Longer Active
			}

			return 0;								// Return To The Message Loop
		}

		case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

		case WM_CLOSE:								// Did We Receive A Close Message?
		{
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		}

		case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
			keys[wParam] = TRUE;					// If So, Mark It As TRUE
			return 0;								// Jump Back
		}

		case WM_KEYUP:								// Has A Key Been Released?
		{
			keys[wParam] = FALSE;					// If So, Mark It As FALSE
			return 0;								// Jump Back
		}

		case WM_SIZE:								// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;								// Jump Back
		}
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}




int WINAPI WinMain(	HINSTANCE	hInstance,			// Instance
					HINSTANCE	hPrevInstance,		// Previous Instance
					LPSTR		lpCmdLine,			// Command Line Parameters
					int			nCmdShow)			// Window Show State
{
	
    MSG		msg;									// Windows Message Structure
	BOOL	done=FALSE;								// Bool Variable To Exit Loop

    // Ask The User Which Screen Mode They Prefer
    
    fullscreen=true;

    // Ask The User Which Screen Mode They Prefer
	if (MessageBox(NULL,"Would You Like To Run In Fullscreen Mode?", "Start FullScreen?",MB_YESNO|MB_ICONQUESTION)==IDNO)
	{
		fullscreen=FALSE;							// Windowed Mode
	}
	
    
    // Create Our OpenGL Window
	if (!CreateGLWindow("The Abyss",800,600,16,fullscreen))
	{
		return 0;									// Quit If Window Was Not Created
	}

	while(!done)									// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
			
            // Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if ((active && !DrawGLScene()) || keys[VK_ESCAPE])	// Active?  Was There A Quit Received?
			{
				done=TRUE;							// ESC or DrawGLScene Signalled A Quit
			}
			else									// Not Time To Quit, Update Screen
			{
				SwapBuffers(hDC);					// Swap Buffers (Double Buffering)
/*				
                if (keys[VK_UP])
                {
                  CPower-=.15;
                  if (CPower < 5) CPower = 5;  

                  //zptrans+=.01;    
//					if (cy > 1.95) cy = 1.95;
//                    else
//                      cy += .025;
                    //XP -= (float)sin(heading*piover180) * 0.1f;	
					//ZP -= (float)cos(heading*piover180) * 0.1f;
//					xpos += xp/150;//(float)sin(heading*piover180) * 0.25f;
//					zpos += zp/150;

                }

                else if (keys[VK_DOWN])
                {
                    CPower+=.15;
                    if (CPower > 40) CPower = 40;
//                  zptrans-=.01;    
//                    if (cy < -1.95) cy = -1.95;
//                    else
//                      cy -= .025;
//					xpos += xp/150;//(float)sin(heading*piover180) * 0.25f;
//					zpos += zp/150;
//					xpos += (float)sin(heading*piover180) * 0.25f;
//					zpos += (float)cos(heading*piover180) * 0.25f;

                }

			
                if (keys[VK_LEFT])
                {

                  //xptrans+=.01;    
                  CAngle -= .02;
                
                }

               
                else if (keys[VK_RIGHT])
                {
                  CAngle += .02; 
                }

                
                if (keys['W'] && !wp)
                {
 				  wp=TRUE;
				  wireframe=!wireframe;                   
                }

				if (!keys['W'])
				{
					wp=FALSE;
				}
*/
                if (keys[VK_ADD])
                {                 
                  ZOOM+=.1;
                  
                }
                
                if (keys[VK_SUBTRACT])
                {                 
                  ZOOM-=.1; 
                  
                }
 /*               
                if(keys[VK_NEXT])
                {
                  yptrans2+=.05;
                  if (yptrans2 > 0) yptrans2*=.9;
                }

                if(keys[VK_PRIOR])
                {
                  yptrans2-=.05;
                  if (yptrans2 < -8) yptrans2*=.99;
                }
*/
                /*
                if (keys['L'] && !lp)
				{
					lp=TRUE;
					light=!light;
					if (!light)
					{
						glDisable(GL_LIGHTING);
					}
					else
					{
						glEnable(GL_LIGHTING);
					}
				}
				if (!keys['L'])
				{
					lp=FALSE;
				}
				*/
                
                /*
                if (keys['F'] && !fp)
				{
					fp=TRUE;
					filter+=1;
					if (filter>2)
					{
						filter=0;
					}
				}
				if (!keys['F'])
				{
					fp=FALSE;
				}
				*/
                
/*
                if (keys[' '] && !sp)
				{
					sp=TRUE;
					Launch = true;
                    
				}
				if (!keys[' '])
				{
					sp=FALSE;
				}
*/
			}
		}
	}

	// Shutdown
	KillGLWindow();									// Kill The Window
// SCREEN SAVER //	return ScrExecute(hInstance,MySaverProc);
    return (msg.wParam);							// Exit The Program
}
